/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2024 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone.io                             **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef TOOLPRESETLIST_GUI_H
#define TOOLPRESETLIST_GUI_H

#include "abstracttoolgui.h"

namespace Ui {
class ToolPresetList_gui;
}

class ToolPresetList_gui : public AbstractToolGui
{
    Q_OBJECT

public:
    explicit ToolPresetList_gui(QWidget *parent = nullptr);
    ~ToolPresetList_gui();

    /// Update the interface with the parameters
    void updateInterface(AbstractToolParameters * parameters, IdList ids) override;

    /// Save the parameters based on the interface
    void saveParameters(AbstractToolParameters * parameters) override;

private slots:
    void on_radioCsv_clicked();
    void on_radioHtml_clicked();
    void on_pushCopy_clicked();
    void on_pushClose_clicked();

private:
    Ui::ToolPresetList_gui *ui;
    QMap<int, QMap<int, QString> > _mapName;
};

#endif // TOOLPRESETLIST_GUI_H
